randomconfig fixes
[oweals/busybox.git] / scripts / trylink
index 25629aa1af24170c8a2e27f88df11fdf338e8af7..8c8854679be80d0294ebb3e807c3a446a1fa8933 100755 (executable)
@@ -41,17 +41,68 @@ try() {
     printf "%s\n" "$*" >>$EXE.out
     printf "%s\n" "==========" >>$EXE.out
     $debug && echo "Trying: $*"
-    "$@" >>$EXE.out 2>&1
-    exitcode=$?
-    return $exitcode
+    $@ >>$EXE.out 2>&1
+    return $?
+}
+
+check_cc() {
+    local tempname="/tmp/temp.$$.$RANDOM"
+    # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
+    # "-xc": C language. "/dev/null" is an empty source file.
+    if $CC $1 -shared -xc /dev/null -o "$tempname".o >/dev/null 2>&1; then
+       echo "$1";
+    else
+       echo "$2";
+    fi
+    rm "$tempname".o 2>/dev/null
+}
+
+check_libc_is_glibc() {
+    local tempname="/tmp/temp.$$.$RANDOM"
+    echo "\
+       #include <stdlib.h>
+       /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
+       #if defined(__GLIBC__) && !defined(__UCLIBC__)
+       syntax error here
+       #endif
+       " >"$tempname".c
+    if $CC "$tempname".c -c -o "$tempname".o >/dev/null 2>&1; then
+       echo "$2";
+    else
+       echo "$1";
+    fi
+    rm "$tempname".c "$tempname".o 2>/dev/null
 }
 
 EXE="$1"
 CC="$2"
-LDFLAGS="$3"
-O_FILES="$4"
-A_FILES="$5"
-LDLIBS="$6"
+CFLAGS="$3"
+LDFLAGS="$4"
+O_FILES="$5"
+A_FILES="$6"
+LDLIBS="$7"
+
+# The --sort-section option is not supported by older versions of ld
+SORT_SECTION=`check_cc "-Wl,--sort-section,alignment" ""`
+
+# Static linking against glibc produces buggy executables
+# (glibc does not cope well with ld --gc-sections).
+# See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
+# Note that glibc is unsuitable for static linking anyway.
+# We are removing -Wl,--gc-sections from link command line.
+GC_SECTIONS=`(
+. ./.config
+if test x"$CONFIG_STATIC" = x"y"; then
+    check_libc_is_glibc "" "-Wl,--gc-sections"
+else
+    echo "-Wl,--gc-sections"
+fi
+)`
+
+# The --gc-sections option is not supported by older versions of ld
+if test -n "$GC_SECTIONS"; then
+    GC_SECTIONS=`check_cc "$GC_SECTIONS" ""`
+fi
 
 # Sanitize lib list (dups, extra spaces etc)
 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
@@ -61,15 +112,15 @@ echo "Trying libraries: $LDLIBS"
 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
-try $CC $LDFLAGS \
+try $CC $CFLAGS $LDFLAGS \
        -o $EXE \
        -Wl,--sort-common \
-       -Wl,--sort-section -Wl,alignment \
-       -Wl,--gc-sections \
+       $SORT_SECTION \
+       $GC_SECTIONS \
        -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
        $l_list \
 || {
-    echo "Failed: $* $l_list"
+    echo "Failed: $l_list"
     cat $EXE.out
     exit 1
 }
@@ -79,50 +130,54 @@ try $CC $LDFLAGS \
 while test "$LDLIBS"; do
     $debug && echo "Trying libraries: $LDLIBS"
     all_needed=true
+    last_needed=false
     for one in $LDLIBS; do
        without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
        # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
        l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
-       test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
+       test x"$l_list" != x"" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
        $debug && echo "Trying -l options: '$l_list'"
-       try $CC $LDFLAGS \
+       try $CC $CFLAGS $LDFLAGS \
                -o $EXE \
                -Wl,--sort-common \
-               -Wl,--sort-section -Wl,alignment \
-               -Wl,--gc-sections \
+               $SORT_SECTION \
+               $GC_SECTIONS \
                -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
                $l_list
        if test $? = 0; then
-           echo "Library $one is not needed"
+           echo " Library $one is not needed, excluding it"
            LDLIBS="$without_one"
            all_needed=false
+           last_needed=false
        else
-           echo "Library $one is needed"
+           echo " Library $one is needed, can't exclude it (yet)"
+           last_needed=true
        fi
     done
     # All libs were needed, can't remove any
     $all_needed && break
-    # If there is no space char, the list has just one lib.
-    # I'm not sure that in this case lib really is 100% needed.
-    # Let's try linking without it anyway... thus commented out.
-    #{ echo "$LDLIBS" | grep -q ' '; } || break
+    # Optimization: was the last tried lib needed?
+    if $last_needed; then
+       # Was it the only one lib left? Don't test again then.
+       { echo "$LDLIBS" | grep -q ' '; } || break
+    fi
 done
 
 # Make the binary with final, minimal list of libs
-echo "Final link with: $LDLIBS"
+echo "Final link with: ${LDLIBS:-<none>}"
 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
 # --verbose gives us gobs of info to stdout (e.g. linker script used)
 if ! test -f busybox_ldscript; then
-    try $CC $LDFLAGS \
+    try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
            -Wl,--sort-common \
-           -Wl,--sort-section -Wl,alignment \
-           -Wl,--gc-sections \
+           $SORT_SECTION \
+           $GC_SECTIONS \
            -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
            $l_list \
            -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
+           -Wl,-Map,$EXE.map \
            -Wl,--verbose \
     || {
        cat $EXE.out
@@ -136,16 +191,16 @@ else
     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
     # This will eliminate most of the padding (~3kb).
     # Hmm, "ld --sort-section alignment" should do it too.
-    try $CC $LDFLAGS \
+    try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
            -Wl,--sort-common \
-           -Wl,--sort-section -Wl,alignment \
-           -Wl,--gc-sections \
-           -Wl,-T -Wl,busybox_ldscript \
+           $SORT_SECTION \
+           $GC_SECTIONS \
+           -Wl,-T,busybox_ldscript \
            -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
            $l_list \
            -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
+           -Wl,-Map,$EXE.map \
            -Wl,--verbose \
     || {
        cat $EXE.out
@@ -166,7 +221,7 @@ if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
     ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
 
     EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
-    try $CC $LDFLAGS \
+    try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
            -shared -fPIC \
            -Wl,--enable-new-dtags \
@@ -174,11 +229,11 @@ if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
            -Wl,-soname="libbusybox.so.$BB_VER" \
            -Wl,--undefined=lbb_main \
            -Wl,--sort-common \
-           -Wl,--sort-section -Wl,alignment \
+           $SORT_SECTION \
            -Wl,--start-group $A_FILES -Wl,--end-group \
            $l_list \
            -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
+           -Wl,-Map,$EXE.map \
            -Wl,--verbose \
     || {
        echo "Linking $EXE failed"
@@ -192,15 +247,15 @@ fi
 
 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
     EXE="$sharedlib_dir/busybox_unstripped"
-    try $CC $LDFLAGS \
+    try $CC $CFLAGS $LDFLAGS \
            -o $EXE \
            -Wl,--sort-common \
-           -Wl,--sort-section -Wl,alignment \
-           -Wl,--gc-sections \
+           $SORT_SECTION \
+           $GC_SECTIONS \
            -Wl,--start-group $O_FILES -Wl,--end-group \
            -L"$sharedlib_dir" -lbusybox \
            -Wl,--warn-common \
-           -Wl,-Map -Wl,$EXE.map \
+           -Wl,-Map,$EXE.map \
            -Wl,--verbose \
     || {
        echo "Linking $EXE failed"
@@ -220,24 +275,22 @@ if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
     while read name main junk; do
 
        echo "\
-void lbb_prepare(char **argv);
+void lbb_prepare(const char *applet, char **argv);
 int $main(int argc, char **argv);
 
-const char *applet_name = \"$name\";
-
 int main(int argc, char **argv)
 {
-       lbb_prepare(argv);
+       lbb_prepare(\"$name\", argv);
        return $main(argc, argv);
 }
 " >"$sharedlib_dir/applet.c"
 
        EXE="$sharedlib_dir/$name"
-       try $CC $LDFLAGS "$sharedlib_dir/applet.c" \
+       try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
                -o $EXE \
                -Wl,--sort-common \
-               -Wl,--sort-section -Wl,alignment \
-               -Wl,--gc-sections \
+               $SORT_SECTION \
+               $GC_SECTIONS \
                -L"$sharedlib_dir" -lbusybox \
                -Wl,--warn-common \
        || {